// FsPacker.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <conio.h>

#include "class\CustomPack.h"

bool initialize(char* exePath)
{		
	HINSTANCE newInstanceHandle = GetModuleHandle(NULL);


	bool result = true;

	HKEY keyHandle;
	char value[MAX_PATH];
	LONG regResult;

	regResult = RegCreateKeyEx(HKEY_CLASSES_ROOT , "Directory\\shell\\FileSystem.Pack", 0, NULL,
	REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, 
	&keyHandle, NULL);


	if (regResult==ERROR_SUCCESS){
		
		ZeroMemory(value,sizeof(value));

		strcpy(value,"Convert to Pak File...");
		RegSetValueEx(keyHandle, NULL, 0, REG_SZ, 
				(BYTE*) value, 
				(strlen(value) + 1)
			);


		RegCloseKey(keyHandle);
	}

	regResult = RegCreateKeyEx(HKEY_CLASSES_ROOT , "Directory\\shell\\FileSystem.Pack\\command", 0, NULL,
		REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, 
		&keyHandle, NULL);	

	if (regResult==ERROR_SUCCESS){
				
		ZeroMemory(value,sizeof(value));

		strcpy(value,"\"");
		strcat(value,exePath);
		strcat(value,"\" \"%1\"");

		RegSetValueEx(keyHandle, NULL, 0, REG_SZ, 
				(BYTE*) value, 
				(strlen(value) + 1)
			);


		RegCloseKey(keyHandle);


	}

	return result;

}

int main(int argc, char* argv[])
{

	initialize(argv[0]);
	
	printf ("Packer tool\n\n");

	if (argc < 2){
		
		printf ("FSPACKER directory [pakfile] [blocksize=262144]\n\n");

		printf ("\tdirectory\n");
		printf ("\t\tbase directory to conver to a pak file.\n");

		printf ("\tpakfile\n");
		printf ("\t\toutput pak file name.\n");

		printf ("\tblocksize\n");
		printf ("\t\tblock size in bytes.\n\n");

		printf ("Note : Youl could use the explorer to make your pack files.\n");
		printf ("Select a folder in My Computer or Explorer and right click over it.\n");
		printf ("In the popup menu, select \"Convert to Pak File...\" to make the .ypf file with the folder content.");
		
	}else{
		
		char basedir[MAX_PATH];
		char fileName[MAX_PATH];

		ZeroMemory(basedir,sizeof(basedir));
		ZeroMemory(fileName,sizeof(fileName));

		DWORD chunksize = 262144;

		strcpy(basedir,argv[1]);

		if (argc>2){

			strcpy(fileName,argv[2]);		
		}else{
	
			strcpy(fileName,basedir);
			strcat(fileName,".fpk");
		}

		

		if (argc>3){
			chunksize = atoi(argv[3]);
		}


		CResult result = resultOk;

		
		CCustomPack pack;

		result = pack.initialize(basedir,fileName,chunksize);


		
		if (result!=resultOk){
			
			printf(result.string);
		}else{
			
			printf("\nTotal : %d File(s) packed. ratio = %04.0f:1000",pack.totalFiles,((float)pack.totalCompress * 1000)/(float)pack.totalUncompress);						
		}

		
		pack.finalize();

	}
		

	printf ("\n\npress a key to exit...\n");

	while(!kbhit() );

	return 0;
}
